package com.biganto.visual.roompark.presentation.screen.photo

import com.biganto.visual.roompark.conductor.BigantoBasePresenter
import com.biganto.visual.roompark.domain.interactor.PhotoInteractor
import com.biganto.visual.roompark.util.monades.ExceptionString
import io.reactivex.Observable
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.schedulers.Schedulers
import timber.log.Timber
import javax.inject.Inject
import javax.inject.Named

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


class PhotoScreenPresenter @Inject constructor(
    private val interactor: PhotoInteractor
    ,@Named(SELECTED_ALBUM_INDEX_KEY) private var selectedIndex:Int
)
    : BigantoBasePresenter<PhotoScreen, PhotoScreenViewState>() {

    override fun defaultErrorViewStateHandler() =
        {e: ExceptionString -> PhotoScreenViewState.SomeError(e) }

    override fun bindIntents() {


//        val fetchSelected = requestAlbum(selectedIndex)
//
//
//        val headerItemSelected = intent(PhotoScreen::onAlbumSelected)
//            .doOnNext { selectedIndex = it.albumId }
//
//            .flatMap<PhotoScreenViewState> { model ->
//                requestAlbum(model.albumId)
//            }

        Timber.d("fetch photoId: $selectedIndex")
        val fetchAlbum = interactor.fetchPhoto(selectedIndex)
            .doOnNext{Timber.d("got photo: $it")}
            .flatMap { photo ->
                Observable.merge<PhotoScreenViewState>(
                    arrayListOf(
                        interactor.getAlbum(photo.albumId)
                            .map { PhotoScreenViewState.AldumFetched(it) }
            ,
                interactor.fetchPhotos(photo.albumId)
                    .doOnNext{Timber.d("got photos: $it")}
                    .map<PhotoScreenViewState> { PhotoScreenViewState.PhotoListLoaded(it) }
                    .startWith(Observable.just(PhotoScreenViewState.PhotoFetched(photo)))
        ))

    }






        val state = restoreStateObservable
                .mergeWith(fetchAlbum)
//            .mergeWith(fetchParents)
//            .mergeWith(fetchSelected)
//            .mergeWith(headerItemSelected)
            .subscribeOn(Schedulers.io())
            .observeOn(AndroidSchedulers.mainThread())
        subscribeViewState(state.cast(PhotoScreenViewState::class.java), PhotoScreen::render)
    }

}